// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "ProceduralMeshComponent.h"
#include "MyActor.generated.h"


UCLASS()
class VURTUE1_API AMyActor : public AActor
{
/*
UMaterialInstanceDynamic* DynMaterial;
UPROPERTY(EditAnywhere, Category = "Dmat")
UMaterialInterface* MaterialToEdit;
UPROPERTY(EditAnywhere, Category = "Dmat")
FLinearColor Color;
*/
UPROPERTY(EditAnywhere, Category = "Dmat")
UMaterialInstanceDynamic *MD;
public:
UPROPERTY(EditAnywhere, Category = "VupObj")
unsigned gid1;
UPROPERTY(EditAnywhere, Category = "VupObj")
unsigned gid2;
UPROPERTY(EditAnywhere, Category = "VupObj")
bool isa;
//virtual void OnConstruction(const FTransform& Transform) override;

	GENERATED_BODY()

public:	
	// Sets default values for this actor's properties
	AMyActor();

protected:
//UMaterialInstanceDynamic *TheMaterial_Dyn;
UMaterial* TheOpaqueMaterial;
UMaterial* TheTransparentMaterial;
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;
		UPROPERTY(VisibleAnywhere,BlueprintReadWrite)
	//TArray<UProceduralMeshComponent*> CustomMeshes;
	UProceduralMeshComponent* CustomMesh;

	int CreateMesh(unsigned section,const TArray<FVector> Vertices,const TArray<int32> Triangles, const TArray<FVector>& Normals, const TArray<FVector2D>& UV0,FLinearColor FLC);

};
