// Fill out your copyright notice in the Description page of Project Settings.


#include "MyActor.h"
#include "Runtime/Engine/Classes/Materials/Material.h"
#include "ConstructorHelpers.h"



// Sets default values
AMyActor::AMyActor()
{
CustomMesh = CreateDefaultSubobject<UProceduralMeshComponent>("CustomMesh");
/*
int c;
for (c = 0; c < 16; c++)
	{
	//
	UProceduralMeshComponent *CustomMesh = CreateDefaultSubobject<UProceduralMeshComponent>("CustomMesh");
	CustomMeshes.Add(CustomMesh);
	}
*/
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	static ConstructorHelpers::FObjectFinder<UMaterial> OpaqueMaterial(TEXT("Material'/Game/StarterContent/Materials/M_Basic_Wall.M_Basic_Wall'"));
	static ConstructorHelpers::FObjectFinder<UMaterial> TransparentMaterial(TEXT("Material'/Game/StarterContent/Materials/M_Glass.M_Glass'"));
	if(OpaqueMaterial.Object != NULL)
		{
		TheOpaqueMaterial = (UMaterial*)OpaqueMaterial.Object;
		}
	if(TransparentMaterial.Object != NULL)
		{
		TheTransparentMaterial = (UMaterial*)TransparentMaterial.Object;
		}
}

// Called when the game starts or when spawned
void AMyActor::BeginPlay()
{
	Super::BeginPlay();
}

//void CreateMeshSection(int32 SectionIndex, const TArray<FVector>& Vertices, const TArray<int32>& Triangles, const TArray<FVector>& Normals, const TArray<FVector2D>& UV0, const TArray<FColor>& VertexColors, const TArray<FProcMeshTangent>& Tangents, bool bCreateCollision)


int AMyActor::CreateMesh(unsigned section,const TArray<FVector> Vertices,const TArray<int32> Triangles, const TArray<FVector>& Normals, const TArray<FVector2D>& UV0,FLinearColor FLC/*UMaterial *TheMat*/)
{
/*
UProceduralMeshComponent *CustomMesh;
CustomMesh=CustomMeshes[section];
if(CustomMesh)
	{ 
	SetRootComponent(CustomMesh);
	CustomMesh->bUseAsyncCooking = true;
	CustomMeshes.Add(CustomMesh);
	}
else 
	{ 
	return -1;
	}
*/
//if(section==3)
{ 
CustomMesh->CreateMeshSection(section, Vertices, Triangles, Normals,UV0,TArray<FVector2D>(), TArray<FVector2D>(),TArray<FVector2D>(),TArray<FColor>(),TArray<FProcMeshTangent>(),false);
MD=CustomMesh->CreateDynamicMaterialInstance(section,FLC.A==1?TheOpaqueMaterial:TheTransparentMaterial);
//FProcMeshSection *M=CustomMesh->GetProcMeshSection(0);
MD->SetVectorParameterValue("Color", FLC);
}
return 0;
}

// Called every frame
void AMyActor::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}
