// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "ProceduralMeshComponent.h"
#include "vup.generated.h"

UCLASS()
class VURTUE1_API Avup : public AActor
{
UPROPERTY(EditAnywhere, Category = "Vup")
bool Import_From_Vup;

	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	Avup();

protected:
	UMaterialInterface *mopaque,*mtransparent;
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;
	int createobjects(UWorld *world, FSceneInterface *scene, int nsp, struct _extrai3dinfos* pextra,bool connectexisting);
	int tostaticmesh(UWorld *world, FSceneInterface *scene, int nsp, struct _extrai3dinfos* pextra);
	int tostatic(UProceduralMeshComponent* cmesh,int objnum);
	void uninit(void);
public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;
 #if WITH_EDITOR
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
};
